Bug 495693 - Review Request: perl-Syntax-Highlight-Perl6 - Perl 6 Syntax Highlighter
Review Request: perl-Syntax-Highlight-Perl6 - Perl 6 Syntax Highlighter
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Iain Arnell
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 500959
  Show dependency treegraph
 
Reported: 2009-04-14 08:50 EDT by Marcela Mašláňová
Modified: 2010-02-12 07:33 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-02-12 07:33:45 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
iarnell: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Marcela Mašláňová 2009-04-14 08:50:52 EDT
Spec URL: http://mmaslano.fedorapeople.org/review/perl-Syntax-Highlight-Perl6.spec
SRPM URL: http://mmaslano.fedorapeople.org/review/perl-Syntax-Highlight-Perl6-0.040-1.fc11.src.rpm
Description: Syntax::Highlight::Perl6 parses Perl 6 source code using an embedded
STD.pm. It matches parse tree nodes to colors then returns them in
different output formats. It can be used to create web pages with colorful
source code samples in its simple and snippet html modes, or it can be used
as a learning tool in examining STD.pm's output using the JavaScript node
viewer in its full html mode. Or you can use its parse tree Perl 5 records
to build your next great idea.
Comment 1 Iain Arnell 2009-04-14 23:33:16 EDT
+ source files match upstream.  
  ac5652afbe2a89cb5df86cb069c2e6500cfb490e  Syntax-Highlight-Perl6-0.040.tar.gz

+ package meets naming and versioning guidelines.
+ specfile is properly named, is cleanly written and uses macros consistently.
+ summary is OK.
+ description is OK.
+ dist tag is present.
+ build root is OK.
- license field could be complicated
  This library also includes the following libraries:
  STD.pm by Larry Wall (Artistic License 2.0)
  JQuery by John Resig (dual licensed under the MIT and GPL licenses).

  more like (GPL+ or Artistic) and Artistic 2.0 and (MIT or GPLv2) ?

+ license is open source-compatible.
+ license text not included upstream.
+ latest version is being packaged.
+ BuildRequires are proper.
+ compiler flags are appropriate.
+ %clean is present.
+ package builds in mock
  https://koji.fedoraproject.org/koji/taskinfo?taskID=1297595

- package installs properly.
  Error: Missing Dependency: perl(STD) is needed by package perl-Syntax-Highlight-Perl6-0.040-1.fc11.noarch (perl-Syntax-Highlight-Perl6-0.040-1.fc11.noarch.rpm)

- rpmlint has complaints:
  perl-Syntax-Highlight-Perl6.noarch: I: checking
  perl-Syntax-Highlight-Perl6.noarch: E: non-executable-script /usr/lib/perl5/vendor_perl/5.10.0/Cursor.pmc 0644
  perl-Syntax-Highlight-Perl6.src: I: checking
  perl-Syntax-Highlight-Perl6.src: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 9)
  2 packages and 0 specfiles checked; 1 errors, 1 warnings.


- final provides are missing (Cursor) and (STD)
  perl(LazyMap)  
  perl(Syntax::Highlight::Perl6) = 0.040
  perl(Syntax::Highlight::Perl6::Actions)  
  perl-Syntax-Highlight-Perl6 = 0.040-1.fc11

+ final requires are sane:
  /usr/bin/perl  
  perl >= 1:5.010
  perl(:MODULE_COMPAT_5.10.0)  
  perl(Carp)  
  perl(Cwd)  
  perl(Encode)  
  perl(English)  
  perl(Exporter)  
  perl(File::Basename)  
  perl(File::Spec)  
  perl(Getopt::Long)  
  perl(Moose) >= 0.67
  perl(Readonly)  
  perl(Readonly) >= 1.03
  perl(STD)  
  perl(Syntax::Highlight::Perl6)  
  perl(Term::ANSIColor)  
  perl(YAML::Syck) >= 1.05
  perl(feature)  
  perl(open)  
  perl(overload)  
  perl(strict)  
  perl(utf8)  
  perl(warnings)  
  rpmlib(CompressedFileNames) <= 3.0.4-1
  rpmlib(FileDigests) <= 4.6.0-1
  rpmlib(PayloadFilesHavePrefix) <= 4.0-1
  rpmlib(VersionedDependencies) <= 3.0.3-1

+ %check is present and all tests pass, though Text::VimColor needs to be
  packaged to complete the suite:
  t/00-syntax.t .... ok
  t/01-vim.t ....... skipped: Text::VimColor is not installed
  t/02-hilitep6.t .. ok
  All tests successful.
  Files=3, Tests=66, 11 wallclock secs ( 0.03 usr  0.01 sys +  3.06 cusr  0.16 csys =  3.26 CPU)
  Result: PASS

+ no shared libraries are added to the regular linker search paths.
+ owns the directories it creates.
+ doesn't own any directories it shouldn't.
+ no duplicates in %files.
+ file permissions are appropriate.
+ no generically named files
+ code, not content.
+ documentation is small, so no -doc subpackage is necessary.
+ %docs are not necessary for the proper functioning of the package.
Comment 2 Marcela Mašláňová 2009-04-16 09:45:02 EDT
> - license field could be complicated
>   This library also includes the following libraries:
>   STD.pm by Larry Wall (Artistic License 2.0)
>   JQuery by John Resig (dual licensed under the MIT and GPL licenses).
> 
>   more like (GPL+ or Artistic) and Artistic 2.0 and (MIT or GPLv2) ?
> 
It looks like all of them are needed.

> - package installs properly.
>   Error: Missing Dependency: perl(STD) is needed by package
This is fixed by providing perl(STD) in this package.

> perl-Syntax-Highlight-Perl6-0.040-1.fc11.noarch
> (perl-Syntax-Highlight-Perl6-0.040-1.fc11.noarch.rpm)
> 
> - rpmlint has complaints:
>   perl-Syntax-Highlight-Perl6.noarch: E: non-executable-script
> /usr/lib/perl5/vendor_perl/5.10.0/Cursor.pmc 0644
Other scripts in this directory aren't executable.

> - final provides are missing (Cursor) and (STD)
Cursor should be used only as internal part, so it shouldn't be provided? 

>   t/01-vim.t ....... skipped: Text::VimColor is not installed
I'll made a review ticket for this requirement and then upload new package with koji build.
Comment 3 Iain Arnell 2009-04-16 10:31:56 EDT
(In reply to comment #2)
> > - rpmlint has complaints:
> >   perl-Syntax-Highlight-Perl6.noarch: E: non-executable-script
> > /usr/lib/perl5/vendor_perl/5.10.0/Cursor.pmc 0644
> Other scripts in this directory aren't executable.

Yep - looks like its caused by the shebang. Rather than use a patch to fix the path, how about just removing it instead?

> > - final provides are missing (Cursor) and (STD)
> Cursor should be used only as internal part, so it shouldn't be provided? 

it gets installed and is "use"able - why not provide it?
Comment 4 Marcela Mašláňová 2009-04-22 09:53:37 EDT
Hm after a few changes Cursor can't be provided because rpmlint is complaining. STD is provided. Please check new version
http://mmaslano.fedorapeople.org/review/perl-Syntax-Highlight-Perl6-0.040-2.fc11.src.rpm
http://mmaslano.fedorapeople.org/review/perl-Syntax-Highlight-Perl6.spec

Test in this package are blocked by perl-Text-VimColor.
Comment 5 Marcela Mašláňová 2009-04-24 03:01:49 EDT
perl-Text-VimColor was built today. 
http://koji.fedoraproject.org/koji/taskinfo?taskID=1318438
Comment 6 Iain Arnell 2009-04-24 09:37:34 EDT
Now autoreq has picked up perl(mangle.pl) which it doesn't provide (and I agree, this one it shouldn't provide), so you'll need to filter it out.

And I see that upstream has been busy and made three new release in the last couple of days! Let's see what new surprises 0.43 brings too (or 0.44...?).
Comment 7 Marcela Mašláňová 2009-04-27 03:26:05 EDT
Yes, I wonder why I packaged Text::VimColor. Maybe I should wait for more stable package, which won't release every second day or until Padre-plugins won't need this package ;-)
Comment 8 Marcela Mašláňová 2009-04-27 03:47:16 EDT
Ok, this is not needed for the latest release of Padre-Plugins so you can close it. I'm not interested in maintainace any more.
Comment 10 Iain Arnell 2010-02-04 11:12:12 EST
+ source files match upstream.  
  10dec91d5a7bb1f1df32e9a87d31de94  Syntax-Highlight-Perl6-0.78.tar.gz

+ package meets naming and versioning guidelines.
+ specfile is properly named, is cleanly written and uses macros consistently.
+ summary is OK.
+ description is OK.
+ dist tag is present.
+ build root is OK.
+ license field matches the actual license.
  (GPL+ or Artistic) and Artistic 2.0 and (MIT or GPLv2)

+ license is open source-compatible.
+ license text not included upstream.
+ latest version is being packaged.
+ BuildRequires are proper.
+ compiler flags are appropriate.
+ %clean is present.
+ package builds in mock
  http://koji.fedoraproject.org/koji/taskinfo?taskID=1963313
+ package installs properly.
- rpmlint has no complaints:
  perl-Syntax-Highlight-Perl6.noarch: I: checking
  perl-Syntax-Highlight-Perl6.noarch: E: wrong-script-interpreter /usr/share/perl5/Cursor.pmc perl
  perl-Syntax-Highlight-Perl6.noarch: E: non-executable-script /usr/share/perl5/Cursor.pmc 0644 perl
  perl-Syntax-Highlight-Perl6.src: I: checking
  perl-Syntax-Highlight-Perl6.src:18: W: unversioned-explicit-provides perl(STD)
  perl-Syntax-Highlight-Perl6.src:18: W: unversioned-explicit-provides perl(mangle.pl)

+ final provides and requires are sane:
  perl(Cursor)  
  perl(DEBUG)  
  perl(LazyMap)  
  perl(NAME)  
  perl(STD)  
  perl(Stash)  
  perl(Syntax::Highlight::Perl6) = 0.78
  perl(Syntax::Highlight::Perl6::Actions)  
  perl(mangle.pl)  
  perl-Syntax-Highlight-Perl6 = 0.78-1.fc13
=
  perl >= 1:5.010
  perl(:MODULE_COMPAT_5.10.1)  
  perl(Carp)  
  perl(Cwd)  
  perl(DEBUG)  
  perl(Encode)  
  perl(Exporter)  
  perl(File::Basename)  
  perl(File::Copy)  
  perl(File::Path)  
  perl(File::Spec)  
  perl(LazyMap)  
  perl(Moose)  
  perl(Moose) >= 0.89
  perl(NAME)  
  perl(STD)  
  perl(Stash)  
  perl(Storable)  
  perl(Term::ANSIColor)  
  perl(YAML::XS)  
  perl(YAML::XS) >= 0.32
  perl(feature)  
  perl(mangle.pl)  
  perl(open)  
  perl(overload)  
  perl(strict)  
  perl(utf8)  
  perl(warnings)  

+ %check is present and all tests pass.
  t/00-syntax.t .... ok
  t/01-std.t ....... ok
  t/02-hilitep6.t .. ok
  All tests successful.
  Files=3, Tests=69, 17 wallclock secs ( 0.04 usr  0.00 sys +  5.21 cusr  0.42 csys =  5.67 CPU)
  Result: PASS

+ no shared libraries are added to the regular linker search paths.
+ owns the directories it creates.
+ doesn't own any directories it shouldn't.
+ no duplicates in %files.
+ file permissions are appropriate.
+ no generically named files
+ code, not content.
+ documentation is small, so no -doc subpackage is necessary.
+ %docs are not necessary for the proper functioning of the package.


It's close.  Only real problem is with rpmlint output.  I guess you can just strip the first line from Cursor.pmc to fix the reported errors.

  perl-Syntax-Highlight-Perl6.noarch: E: wrong-script-interpreter /usr/share/perl5/Cursor.pmc perl
  perl-Syntax-Highlight-Perl6.noarch: E: non-executable-script /usr/share/perl5/Cursor.pmc 0644 perl


But the warnings for unversioned provides should be okay (after all, the automatically detected provides are mostly unversioned too).

  perl-Syntax-Highlight-Perl6.src:18: W: unversioned-explicit-provides perl(STD)
  perl-Syntax-Highlight-Perl6.src:18: W: unversioned-explicit-provides perl(mangle.pl)
Comment 11 Marcela Mašláňová 2010-02-08 05:04:02 EST
It stays only these warnings:
perl-Syntax-Highlight-Perl6.src: W: spelling-error %description -l en_US html -> HTML, ht ml, ht-ml
perl-Syntax-Highlight-Perl6.src: W: spelling-error %description -l en_US pm's -> Pm's, om's, em's
perl-Syntax-Highlight-Perl6.src:19: W: unversioned-explicit-provides perl(STD)
perl-Syntax-Highlight-Perl6.src:19: W: unversioned-explicit-provides perl(mangle.pl)
I hate unversioned provides, but as you said, they have no releases in package.
New version:
http://mmaslano.fedorapeople.org/review/perl-Syntax-Highlight-Perl6-0.78-2.fc13.src.rpm
Comment 12 Iain Arnell 2010-02-08 14:45:19 EST
When did rpmlint start complaining about "bad" spelling? 

For the record, I think there's some nasty namespace pollution, but there's nothing conflicting, and nothing technically wrong, so 

APPROVED.
Comment 13 Marcela Mašláňová 2010-02-09 01:36:00 EST
rpmlint got crazy and criticize all non-dictionary non-american words. I'll be ignoring that.

Thank you for review.
Comment 14 Marcela Mašláňová 2010-02-09 01:37:55 EST
New Package CVS Request
=======================
Package Name: perl-Syntax-Highlight-Perl6
Short Description: Perl 6 Syntax Highlighter
Owners: mmaslano
Branches: 
InitialCC: perl-sig
Comment 15 Jason Tibbitts 2010-02-09 16:02:54 EST
CVS done (by process-cvs-requests.py).

Note You need to log in before you can comment on or make changes to this bug.